{----------------------------------------------------------------------

  TmProgressBar - Just Win32 TProgressBar, but allows smooth progress,
  wo. dashed line. Also optional vertical orientation. Needs updated
  ComCtl32.dll to work (ver 4.71+).

  Copyright 1997, Ahto Tanner (ahto@moonsoftware.ee),
  Moon Software (http://www.moonsoftware.ee).

  This is freeware component, but you may not sell this component or
  include it in your commercial collection w/o asking me first.
  Feel free to compile into commercial apps, though.

  Version 1.0, August 13, 1997
   - initial version, added 2 new properties to original component:
   
     BarStyle  --  bsSolid or bsSegmented
     Orientation  -- boHorizontal or boVertical

-----------------------------------------------------------------------}

unit mProgressBar;

interface

uses
  Classes, Controls, ComCtrls;

type
  TBarStyle = (bsSolid, bsSegmented);
  TOrientation = (boHorizontal, boVertical);

  TmProgressBar = class(TProgressBar)
  private
    FBarStyle: TBarStyle;
    FOrientation: TOrientation;
    procedure SetBarStyle(NewStyle: TBarStyle);
    procedure SetOrientation(NewOrientation: TOrientation);

  protected

  public
    procedure CreateParams(var Params: TCreateParams); override;

  published
    property BarStyle: TBarStyle read FBarStyle write SetBarStyle default bsSolid;
    property Orientation: TOrientation read FOrientation write FOrientation default boHorizontal;

  end;

const
   PBS_SMOOTH = $01;
   PBS_VERTICAL = $04;

procedure Register;

implementation

{---------------------------------------------------------------------------}

procedure TmProgressBar.CreateParams(var Params: TCreateParams); //override;
var
   NewStyles: longint;
begin
   inherited CreateParams(Params);
   NewStyles := 0;
   if FBarStyle = bsSolid then NewStyles := NewStyles or PBS_SMOOTH;
   if FOrientation = boVertical then NewStyles := NewStyles or PBS_VERTICAL;
   Params.Style := Params.Style or NewStyles;
end;

{---------------------------------------------------------------------------}

procedure TmProgressBar.SetBarStyle(NewStyle: TBarStyle);
begin
   if NewStyle <> FBarStyle then begin
      FBarStyle := NewStyle;
      RecreateWnd;
   end;
end;

{---------------------------------------------------------------------------}

procedure TmProgressBar.SetOrientation(NewOrientation: TOrientation);
begin
   if NewOrientation <> FOrientation then begin
      FOrientation := NewOrientation;
      RecreateWnd;
   end;
end;

{---------------------------------------------------------------------------}

procedure Register;
begin
  RegisterComponents('Moon', [TmProgressBar]);
end;

{---------------------------------------------------------------------------}

end.
